<?php
namespace bwdrmx_random_image_namespace;

use bwdrmx_random_image_namespace\PageSettings\Page_Settings;
define( "bwdrmx_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdrmx_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdrmx_randomImage {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdrmx_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdrmx_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdrmx_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdrmx_randomimage_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdrmx-random-image-widgets.php' );
	}

	public function bwdrmx_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdrmx_random_image_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdrmx-random-image-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdrmx_randomimage_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdrmx-randomimage-category',
			[
				'title' => esc_html__( 'Random Image', 'bwdrmx-random-imagetd' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdrmx_all_assets_for_the_public(){

		wp_enqueue_script( 'randomimage-minjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/honeycombs.min.js', array('jquery'), '1.3', true );
		wp_enqueue_script( 'randomimage-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );

		$all_css_file = array(
            'randomimage-plugin-font' => array('randomimage_css_path_define'=>bwdrmx_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/font.css'),
            'randomimage-plugin-main' => array('randomimage_css_path_define'=>bwdrmx_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['randomimage_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdrmx_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'randomimage-admin-main' => array('bwdrmx_path_admin_define'=>bwdrmx_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdrmx_path_admin_define'], null, '1.3', 'all');
        }
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdrmx_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdrmx_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdrmx_randomimage_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdrmx_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdrmx_admin_editor_scripts' ] );
		
		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdrmx_randomImage::instance();